import sys
import socket

wikipedia="en.wikipedia.org"

class Wiki:
	def __init__(self):
		pass

	def fetchTopic(self, topic, host=wikipedia, port=80):
		#resource = "/wiki/" + topic + "?action=raw"
		resource = "/w/index.php?title=" + topic + "&action=raw"
		return self.fetchResource(resource, host, port)

	def fetchResource(self, resource, host, port):
		msg = "GET " + resource + " HTTP/1.0\nFrom: cs6452-spring05@mailman.cc.gatech.edu\nUser-Agent: WikiFarmer/1.0\nHost: en.wikipedia.org\n\n"
		# print "SENDING", msg
		return self.fetchRaw(msg, host, port)

	def fetchRaw(self, message, host, port):
		s = socket.socket(socket.SOCK_STREAM, socket.AF_INET)
		s.connect((host, port))
		s.send(message)
		response = ""
		data = s.recv(1024)
		while data:
			response = response + data
			data = s.recv(1024)

		# print "--- fetch raw: response ---"
		# print response
		# print "---- end of response ---"

		idx = response.find('\n')
		hdr = response[0:idx-1]
		if hdr.find("200") != -1:
			return (200, response)
		elif hdr.find("404") != -1:
			return (404, response)
		elif hdr.find("301") != -1 or hdr.find("302") != -1 or hdr.find("303") != -1:
			return self.redirect(response)
		elif hdr.find("500") != -1:
			return (500, response)
		else:
			print "Unknown response from server: ", response
			return (000, response)

	def redirect(self, data):
		# print "REDIRECTING..."
		host = wikipedia
		port = 80
		idx = data.find("\nLocation: ")
		if idx == -1:
			return (300, None, "No location header in response")
		locLine = data[idx + len("\nLocation: "):]
		idx = locLine.find("\n")
		locLine = locLine[0:idx-1]	# this should be the URL
		idx = locLine.find("http://")
		if idx == -1:
			return (300, None, "Not an HTTP URL: " + locLine)
		locLine = locLine[idx + len("http://"):]
		idx = locLine.find("/")
		if idx == -1:
			return (300, None, "No resource in header: " + locLine)
		host = locLine[0:idx]
		# print "Host is", host
		resource = locLine[idx:]
		# print "Resource is", resource
		if host and resource:
			return self.fetchResource(resource, host, port)
		else:
			return (300, None, "Unknown URL")

if __name__ == "__main__":
	wf = Wiki()
	results = wf.fetchTopic(sys.argv[1])
	print results[1]
	

